/*
OpenFire, a electrical Firework

License:
"OpenFire" by Jennifer Sirtl (jennifer.sirtl@mostfun.de) is licensed under CC BY 4.0

<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="Creative Commons Lizenzvertrag" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/88x31.png" /></a>
<br />Dieses Werk ist lizenziert unter einer <a rel="license" href="http://creativecommons.org/licenses/by/4.0/">Creative Commons Namensnennung 4.0 International Lizenz</a>.

*/


#include <Arduino.h>
#include "config.h"
#include "raise.h"

#ifdef SOUND_ON
extern DFPlayerMini_Fast myDFPlayer;
#endif

void Comet(uint32_t c, uint8_t Direction, uint8_t wait, uint8_t Shape_Num){
  #ifdef SOUND_ON
    myDFPlayer.play(2);  
  #endif
  Shoot_1(c, wait,Shape_Num); //Rise up
  #ifdef SOUND_ON
    myDFPlayer.play(22);  
  #endif
  uint16_t Beginn;
  int Frame, Led_Index,n;  
  unsigned long Pattern[NUM_LEDS_Strip];

  Pattern[0]=0;
  Pattern[1]=c & Shape[Shape_Num][4];
  Pattern[2]=c & Shape[Shape_Num][3];
  Pattern[3]=c & Shape[Shape_Num][2];
  Pattern[4]=c & Shape[Shape_Num][1];
  Pattern[5]=c & Shape[Shape_Num][0];
  if (Shape_Num!=2) {
    Pattern[6]=c & 0xFFFFFF;
  }
  else {
    Pattern[6]=c & 0x000000;       
  }
  Beginn=6;

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){     
        leds[Led_Index+Direction*NUM_LEDS_Strip]=Pattern[n]; 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait*2);  
  } 
  return;
}

void Salut(uint32_t c, uint8_t wait, uint8_t Shape_Num){
  #ifdef SOUND_ON
    myDFPlayer.play(2);  
  #endif
  Shoot_1(c, wait,Shape_Num); //Rise up
  byte n;
  
    for(n=0;n<=NUM_Strips;n++){
        leds[0+n*NUM_LEDS_Strip]=0xFFFFFF; 
      }
   
    FastLED.show();
    
    delay(wait/2);  
    
    for(n=0;n<=NUM_Strips;n++){
        leds[0+n*NUM_LEDS_Strip]=0x000000; 
      }
    FastLED.show();
    #ifdef SOUND_ON
      myDFPlayer.play(4);  
    #endif     
    delay(500);
  return;
}
