/*
OpenFire, a electrical Firework

License:
"OpenFire" by Jennifer Sirtl (jennifer.sirtl@mostfun.de) is licensed under CC BY 4.0

<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="Creative Commons Lizenzvertrag" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/88x31.png" /></a>
<br />Dieses Werk ist lizenziert unter einer <a rel="license" href="http://creativecommons.org/licenses/by/4.0/">Creative Commons Namensnennung 4.0 International Lizenz</a>.
Config for Sample OpenFire 3 with ArduinoDue
*/

//Initial OpenFire
#ifndef INITIAL_OPENFIRE
#define INITIAL_OPENFIRE

#define DEBUG //serial debug //Deactivate if not used (Teensy)
//#define SOUND_ON //Switch on Sound Module
#define OpenFire3 //Switch to OpenFire3


#define LEDTyp  2811 //or 2811

#include <Arduino.h>
#include <FastLED.h> // Fastled library to control the LEDs

#define NUM_LEDS_Strip 15
#define NUM_LEDS_Strip_Shoot 30
#define NUM_Strips 20
#define NUM_LEDS NUM_LEDS_Strip*NUM_Strips      //Sum of LED on Effect


#define LED_PIN_Shoot 4 //Pin of Ascent-Effect 

#ifndef OpenFire3
  #define LED_PIN 22 //OpenFire 1 and 2: Pin of Main Effect, OpenFire3: Sorry, Pins has to be defined in main program.
#endif


extern CRGB leds[NUM_LEDS];
extern CRGB leds_Shoot[NUM_LEDS_Strip_Shoot];

extern uint32_t Shape[][5];
#ifdef SOUND_ON
  #include <DFPlayerMini_Fast.h>//MP3-Player library
#endif


#endif
