/*
OpenFire, a electrical Firework

License:
"OpenFire" by Jennifer Sirtl (jennifer.sirtl@mostfun.de) is licensed under CC BY 4.0

<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="Creative Commons Lizenzvertrag" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/88x31.png" /></a>
<br />Dieses Werk ist lizenziert unter einer <a rel="license" href="http://creativecommons.org/licenses/by/4.0/">Creative Commons Namensnennung 4.0 International Lizenz</a>.

*/

#include <Arduino.h>
#include "config.h"
#include "raise.h"

#ifdef SOUND_ON
extern DFPlayerMini_Fast myDFPlayer;
#endif

void Crackling (uint32_t c, uint8_t wait,uint8_t Shape_Num){
  uint16_t i,s,p, Beginn;// Tail;
  int Frame, Led_Index,n;  
  unsigned long Pattern[4][NUM_LEDS_Strip];

  #ifdef SOUND_ON
    myDFPlayer.play(2);  //Play the first mp3
  #endif
  Shoot_2(0xFF3200, 64,1); // Fire
  #ifdef SOUND_ON
    myDFPlayer.play(16);  //Play the first mp3
  #endif
  
  for (s=0;s<4;s++){
    for (i=0;i<NUM_LEDS_Strip;i++){
      if (random(10)<4){
        Pattern[s][i]=c;      
      }
      else{
        Pattern[s][i]=0x000000;
      }
    }
  }

  Beginn=10; p=0; 

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){    
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){ 
          if (random(10)<4) leds[Led_Index+(s*NUM_LEDS_Strip)]=Pattern[p][n]; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(10);   
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){   
          leds[Led_Index+(s*NUM_LEDS_Strip)]=0x000000; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();   
    delay(20); 
    ///----
        Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){ 
          if (random(10)<4) leds[Led_Index+(s*NUM_LEDS_Strip)]=Pattern[p][n]; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(10);   
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){   
          leds[Led_Index+(s*NUM_LEDS_Strip)]=0x000000; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();   
    delay(wait);   
  } 
  return;
}

void TdV (uint8_t color,uint8_t density,uint8_t sustain, uint8_t wait){//colortable(0..3),density(0)=no random, (1..9), sustain(0..1)=0=off, delay(ms)//gold silver
  uint16_t i,s;
  int Frame; 
  int Led_Index; //Pointer for Start
  int Beginn;  

  const uint8_t Star_Ptr_max=25;
  const uint8_t Pattern_Index_max=5;
  const uint8_t Pattern_Ptr_max=15;
  const uint16_t Loop_max=3;
  unsigned int Pattern_Index;
  unsigned int Pattern_Ptr;
  unsigned int Strip_Index;
  unsigned int Strip_Ptr;
  unsigned int Star_PTR;
 
  const uint32_t Star[5][Star_Ptr_max]={
     {0x000000,0x010000,0x010000,0x080000,0x000000,0x010000,0xFF0000,0x010000,0x010000,0xFF0000,//TdV
      0x010000,0x040000,0x010000,0xFF0000,0x100000,0x080000,0x040000,0x010000,0x080000,0x010000,
      0x000000,0xFF0000,0x080000,0x100000,0x010000},
     {0x000000,0x000100,0x000400,0x00FF00,0xFF0000,0x040000,0x010000,0x000000,0x000000,0x000000,//red green
      0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,
      0x000000,0x000000,0x000000,0x000000,0x010000},
     {0x000000,0x200C00,0x200C00,0x0A0500,0x000000,0x000000,0x200C00,0x000000,0x000000,0x200C00,//gold
      0x200C00,0x000000,0x030100,0x000000,0x0A0500,0x200C00,0x200C00,0x000000,0x000000,0x030100,
      0x000000,0x200C00,0x030100,0x0A0500,0x000000},
     {0x000000,0x200C00,0x000000,0x140900,0x000000,0x0A0500,0xFFFFFF,0x000000,0xFFFFFF,0x000000,//Gold Silver
      0x000000,0x040404,0x000000,0x040404,0x000000,0x000000,0x140900,0x000000,0x000000,0x000000,
      0x000000,0x000000,0x000000,0x000000,0x000000},
     {0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,//Empty
      0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,
      0x000000,0x000000,0x000000,0x000000,0x000000}
      };
   uint8_t Pattern[Pattern_Index_max][Pattern_Ptr_max];

    #ifdef SOUND_ON
      myDFPlayer.play(2);  
    #endif
    Shoot_1(0xFF3200, 64,1); //Rise up
    #ifdef SOUND_ON
      myDFPlayer.play(17);  
    #endif

    if (density!=0){
      //generate random patterns
      for (s=0;s<Pattern_Index_max;s++){
        for (i=0;i<Pattern_Ptr_max;i++){
          if (random(10)<density){
            Pattern[s][i]=random(Star_Ptr_max);   
          }
          else{
            Pattern[s][i]=0x000000;
          }
        }
      }
    }
    else{
      for (s=0;s<Pattern_Index_max;s++){
        for (i=0;i<Pattern_Ptr_max;i++){
          if (i<NUM_LEDS_Strip){
            Pattern[s][i]=(i%Star_Ptr_max);  
          }
          else{
            Pattern[s][i]=0x000000;             
          }
        }
      }    
    }
  
    Beginn=-15; 
    Pattern_Ptr=0;
    Pattern_Index=0;
  
    while (Beginn<=NUM_LEDS_Strip){
      for(Strip_Index=0;Strip_Index<NUM_Strips;Strip_Index++){
        for(Strip_Ptr=0;Strip_Ptr<NUM_LEDS_Strip;Strip_Ptr++){
          if(((byte(Pattern_Ptr-Beginn))<Pattern_Ptr_max)){
            leds[Strip_Ptr+(Strip_Index*NUM_LEDS_Strip)]=Star[color][Pattern[Strip_Index % Pattern_Index_max][byte((Pattern_Ptr-Beginn)%Pattern_Ptr_max)]];   
          }
          else{
            leds[Strip_Ptr+(Strip_Index*NUM_LEDS_Strip)]=0x000000; 
          }
        Pattern_Ptr++; 
  
        }
        Pattern_Ptr=0;
      }
     Beginn++;
    FastLED.show();
    
    delay(wait);
      if (sustain>0){
        for (s=0;s<Pattern_Index_max;s++){
          for (i=0;i<Pattern_Ptr_max;i++){
              if (Pattern[s][i]>0) Pattern[s][i]--;      
          }
        }  
      }
    }
   return;
}
